// This file contains the main theme overrides for the django admin.
@import 'settings';
@import 'mixins';

@mixin colorscheme {
    // Colors
    --color-black: #000000;
    --color-white: #ffffff;
    --color-gray-50: #f8f8f8;
    --color-gray-100: #f4f4f4;
    --color-gray-150: #eeeeee;
    --color-gray-200: #e7e7e7;
    --color-gray-300: #e1e4e8;
    --color-gray-400: #cccccc;
    --color-gray-500: #909090;
    --color-gray-600: #757575;
    --color-gray-700: #586069;
    --color-gray-800: #424242;
    --color-gray-900: #24292e;

    --color-blue: #447e9b;
    --color-blue-light: #79aec8;
    --color-blue-medium: #417690;
    --color-blue-dark: #036;
    --color-red: #ba2121;
    --color-red-dark: #993333;
    --color-yellow: #ffffd4;
    --color-green: #9dc700;
    --color-green-light: #e8ffe8;

    // Custom
    --input-bg: #fcfcfc;

    // Django
    // Theses variables matched from Django's base.css
    --primary: var(--color-blue-light);
    --secondary: var(--color-blue-medium);
    --accent: var(--color-yellow);
    --primary-fg: var(--color-white);

    --body-fg: var(--color-gray-800);
    --body-bg: var(--color-white);
    --body-quiet-color: var(--color-gray-700);
    --body-loud-color: var(--color-black);

    --header-color: var(--color-gray-200);
    --header-branding-color: var(--color-white);
    --header-bg: var(--color-gray-900);
    --header-link-color: var(--color-gray-200);
    --header-link-hover-color: var(--color-white);

    --breadcrumbs-fg: var(--color-black);
    --breadcrumbs-link-fg: var(--color-gray-500);
    --breadcrumbs-bg: var(--color-gray-50);

    --link-fg: var(--color-blue);
    --link-hover-color: var(--color-blue-dark);
    --link-selected-fg: var(--link-hover-color);

    --hairline-color: var(--color-gray-300);
    --border-color: var(--color-gray-400);

    --error-fg: var(--color-red);
    --error-fg-dark: var(--color-red-dark);

    --message-success-bg: var(--color-green-light);
    --message-warning-bg: var(--color-yellow);
    --message-error-bg: var(--color-yellow);

    --darkened-bg: var(--color-gray-50); /* A bit darker than --body-bg */
    --selected-bg: #e4e4e4; /* E.g. selected table cells */
    --selected-row: var(--color-yellow);

    --button-fg: var(--color-white);
    --button-bg: var(--primary);
    --button-hover-bg: #609ab6;
    --default-button-bg: var(--secondary);
    --default-button-hover-bg: #205067;
    --close-button-bg: #888; /* Previously #bbb, contrast 1.92 */
    --close-button-hover-bg: var(--color-gray-600);
    --delete-button-bg: #ba2121;
    --delete-button-hover-bg: #a41515;

    --object-tools-fg: var(--button-fg);
    --object-tools-bg: var(--color-gray-500);
    --object-tools-hover-bg: var(--primary);

    --font-family-primary: Roboto, -apple-system, BlinkMacSystemFont, 'Segoe UI', system-ui, 'Helvetica Neue', Arial,
        sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol', 'Noto Color Emoji';
    --font-family-monospace: ui-monospace, Menlo, Monaco, 'Cascadia Mono', 'Segoe UI Mono', 'Roboto Mono', 'Oxygen Mono',
        'Ubuntu Monospace', 'Source Code Pro', 'Fira Mono', 'Droid Sans Mono', 'Courier New', monospace,
        'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol', 'Noto Color Emoji';
}

// Include color scheme
html[data-theme='light'],
:root {
    @include colorscheme;
}

// We do not support dark mode, so force normal color scheme to be used
@media (prefers-color-scheme: dark) {
    :root {
        @include colorscheme;
    }
}

body {
    // show content once ready class is added
    &:not(.ready) {
        #content {
            opacity: 0;
        }
    }
}

// outdatedbrowser.js
#outdated {
    z-index: 9999999 !important;
}

// Style overrides
h1 {
    font-size: 18px;
    font-weight: 400;
    color: var(--body-fg);
}

thead {
    th,
    td {
        font-weight: normal;
    }
}

small {
    font-size: 13px;
    letter-spacing: 0;
}

// form inputs
input[type='text'],
input[type='password'],
input[type='email'],
input[type='url'],
input[type='number'],
input[type='tel'],
textarea,
select,
.vTextField {
    padding: 7px 6px 6px;
    border-radius: 3px;

    &:not(:focus) {
        background: var(--input-bg);
    }
}

// breadcrumbs
div.breadcrumbs {
    padding: 7px 30px 6px 30px;
    border-bottom: solid 1px var(--hairline-color);

    a,
    span {
        padding: 0 6px 0 2px;

        &:first-child {
            padding-left: 0;
        }
    }

    a {
        &:focus,
        &:hover {
            color: var(--color-gray-700);
        }

        &:not(:last-child) {
            &::after {
                content: '›';
                color: var(--breadcrumbs-fg);
                margin-left: 10px;
            }
        }
    }

    @media (max-width: ($tablet-width - 1px)) {
        padding-left: 15px;
        padding-right: 15px;
    }
}

// Admin header
#header {
    line-height: 30px;
    padding: 6px 12px;
    box-sizing: border-box;

    // Mobile header
    @media (min-width: $min-fixed-header-width) {
        position: fixed;
        z-index: 2000;
        top: 0;
        left: 0;
        width: 100%;
        height: 42px;
        padding: 6px 40px;
    }
}

// Branding (upper left admin title)
#branding {
    #site-name {
        font-size: 18px;
        line-height: 30px;

        a:link,
        a:visited {
            font-size: 15px;
            font-weight: 400;
            padding: 0 2px;
        }
    }

    @media (max-width: 450px) {
        #site-name {
            display: none;
        }
    }
}

// Links in upper right corner header
#user-tools {
    font-size: 12px;
    letter-spacing: 0;
    font-weight: 600;
    color: var(--header-color);
    text-transform: none;

    // User name
    strong {
        margin-right: 10px;
        text-transform: none;
        font-size: 12px;
    }

    // Header links
    #logout-form button,
    a {
        &,
        &:link,
        &:visited {
            padding: 0 4px;
            font-size: 12px;
            letter-spacing: 0;
            font-weight: 600;
            text-transform: none;
            border: 0;

            &:hover {
                color: var(--header-link-hover-color);
            }
            &:focus,
            &:hover {
                color: var(--header-link-hover-color);
            }
        }
    }

    // Hide django theme toggle button in header
    .theme-toggle {
        display: none !important;
    }
}

// Layout
#container {
    position: relative;

    @media (max-width: $desktop-width) {
        min-width: auto;
    }
}

body:not(.popup):not(.login) #container {
    padding-top: 0;

    @media (min-width: $min-fixed-header-width) {
        padding-top: 42px;
    }
}

#content {
    min-height: calc(100vh - 42px);
    padding-left: 30px;
    padding-right: 30px;

    @media (max-width: ($tablet-width - 1px)) {
        padding-left: 15px;
        padding-right: 15px;
    }
}

// Login page
.login {
    height: 70vh;
    display: flex;
    align-items: center;
    justify-content: center;

    #header {
        position: static;
        justify-content: left;
        padding-top: 6px;
        padding-bottom: 6px;

        #site-name {
            display: block;
        }
    }

    #container {
        padding: 0;
        margin: 0 15px;
    }

    #content {
        min-height: 0;
    }

    // Password reset
    .password-reset-link {
        box-sizing: border-box;
        position: fixed;
        left: 0;
        transform: translateY(calc(100% + 20px));
        width: 100%;
        padding: 20px 20px;
        text-align: center;
    }
}

// Password reset input
.form-row.field-email {
    input[type='email'] {
        width: calc(100% - 15px);
        max-width: 400px;
    }
}

// object tools (gray button links shown top right on list/change pages)
.object-tools {
    display: flex;
    flex-wrap: wrap;
    gap: 5px;

    a:link,
    a:visited {
        padding-bottom: 2px;
        background-position: calc(100% - 8px);

        .icon {
            vertical-align: middle;
            font-size: 20px;
        }
    }

    li {
        margin: 0;
    }

    @media (max-width: ($tablet-width - 1px)) {
        float: none;
        margin: 0 0 20px 0;

        li {
            height: auto;

            a:link,
            a:visited {
                float: none;
                display: inline-block;
            }
        }
    }
}

// modules (form fieldsets)
.module caption,
.inline-group h2 {
    background: var(--color-gray-50);
    color: var(--color-gray-900);
    border: solid 1px var(--hairline-color);
    border-bottom: 0;
    border-radius: 2px;
    text-transform: none;
}

.module h2 {
    background: transparent;
    color: var(--color-gray-900);
    border-bottom: solid 1px var(--color-gray-300);
    padding-left: 2px;
    font-size: 18px;
    margin-bottom: 5px;

    a:link,
    a:visited {
        color: var(--color-gray-900);
    }
}

.module caption a:link,
.module caption a:visited {
    color: var(--color-gray-900);
}

.module table {
    border: solid 1px var(--color-gray-300);
}

// changelist toolbar (holds changelist search form)
#changelist #toolbar {
    background: transparent;
    border: 0;

    * {
        box-sizing: border-box;
    }

    label {
        display: none;
    }

    .submit-button {
        position: absolute;
        top: 0;
        right: 0;
        height: 25px;
        padding: 1px 6px 0 4px;
        border: 0;
        box-shadow: none;
        background: transparent;
        cursor: pointer;
        color: #bbb;

        .icon {
            font-size: 20px;
        }
    }

    #changelist-search {
        position: relative;
        box-sizing: border-box;

        input#searchbar {
            width: 100%;
            height: 25px;
            padding: 3px 8px;
        }

        input[type='submit'] {
            visibility: hidden;
            position: fixed;
            left: 0;
            z-index: -1;
        }
    }

    // desktop
    @media (min-width: $tablet-width) {
        position: absolute;
        right: 30px;
        width: 200px !important;
        margin: 10px 0 0 0 !important;
        padding: 0;

        #changelist-search {
            .small {
                position: absolute;
                left: -30px;
                top: 3px;
                transform: translateX(-100%);
            }
        }
    }

    @media (max-width: ($tablet-width - 1px)) {
        padding-left: 0;
        padding-right: 0;

        #changelist-search {
            .small {
                display: block;
                margin-top: 5px;
            }
        }
    }
}

// changelist filter
#changelist-filter {
    position: relative;
    margin-top: 45px;
    flex-basis: 200px;
    padding-bottom: 70px;
    background: transparent;
    border: 0;

    h2 {
        display: none;
    }

    #changelist-filter-clear {
        background-color: transparent;
        padding-left: 0;
        padding-right: 0;
    }

    details {
        margin-bottom: 10px;

        summary {
            padding: 6px 15px 7px 15px;
            margin-top: 0;
            margin-bottom: 0;
            border: solid 1px var(--color-gray-300);
            background: var(--color-gray-50);
            text-transform: lowercase;
        }
    }

    ul {
        padding: 8px 0 10px 15px;
        margin: 0;

        &,
        &:last-child {
            border: solid 1px var(--color-gray-300);
            border-top: 0;
        }
    }

    li {
        margin-left: -15px;
        padding-left: 20px;
    }

    li.selected {
        //border-left-color: var(--color-gray-600);
        padding-left: 15px;
    }

    // Collapsibles
    details > summary {
        position: relative;
        cursor: pointer;
        user-select: none;

        // Collapse icon
        &::before {
            content: '' !important;
            display: block;
            width: 14px;
            height: 14px;
            position: absolute;
            top: 9px;
            right: 7px;
            background-image: url('/s/admin/img/sorting-icons.svg');
            background-repeat: no-repeat;
            background-position: 0 -56px;
        }

        &:hover {
            background: var(--color-gray-150);
        }
    }

    details[open] > summary::before {
        background-position: 0 -28px;
    }

    // Mobile & Tablet
    @media (max-width: ($tablet-width - 1px)) {
        display: none;
    }

    // Desktop
    @media (min-width: $desktop-width) {
        width: 200px;
    }
}

// Changelist
#changelist {
    // Actions dropdown above changelist table
    .actions {
        padding-left: 0;
        padding-right: 0;

        select {
            margin-left: 0;
            font-size: 13px;
            color: var(--color-gray-500);

            &:focus,
            option:not(:first-child) {
                color: var(--color-gray-900);
            }
        }
    }

    // changelist tables
    table {
        border: solid 1px var(--color-gray-300);
    }

    // When filters are present
    &.filtered {
        table {
            border-right: solid 1px var(--color-gray-300);
        }
    }

    // Links for date_hierarchy
    .toplinks {
        border-bottom: 0;
    }

    // pagination links
    .paginator {
        border-top: 0;
    }

    // Table element of results
    #result_list {
        td,
        th {
            position: relative;
            height: 100%;
        }

        td {
            padding: 10px 8px;
        }

        tbody th a:only-child,
        tbody td a:only-child {
            display: inline-block;
            width: 100%;
            height: 100%;

            &:not(:hover) {
                .icon {
                    color: var(--color-gray-700);
                }
            }
        }

        .icon {
            font-size: 50px;
            padding: 10px 30px;
        }
    }

    // tablet up
    @media (min-width: $tablet-width) {
        &.filtered {
            .actions,
            .results,
            .paginator,
            div.xfull {
                margin-right: 230px;
            }
        }
    }

    // mobile
    @media (max-width: ($tablet-width - 1px)) {
        .xfull,
        .results {
            margin-right: 0;
        }

        .toplinks {
            float: none;
            width: 100%;
        }

        .actions {
            display: none !important;
        }

        table {
            th.action-checkbox-column,
            td.action-checkbox {
                display: none;
            }
        }

        &.filtered {
            #toolbar,
            .actions,
            .results,
            .paginator,
            div.xfull {
                margin-right: 0;
            }
        }
    }
}

// tables
table {
    thead {
        th {
            border: solid 1px var(--hairline-color);
            background: var(--darkened-bg);

            &.sorted {
                color: var(--color-gray-900);

                .text {
                    a:link,
                    a:visited,
                    a:focus,
                    a:hover {
                        color: var(--color-gray-900);
                        font-weight: 600;
                    }
                }
            }
        }
    }

    th,
    td {
        border-bottom: solid 1px var(--hairline-color);
    }
}

// changeforms
.change-form {
    #content {
        padding-bottom: 50px;

        > h1 {
            display: inline-block;
            margin-right: 0.8ex;

            & + h2 {
                display: inline-block;
                margin-top: 0;
                font-size: 14px;
            }
        }

        @media (max-width: ($tablet-width - 1px)) {
            #content-main > form {
                margin-top: 10px;
            }
        }
    }
}

// Custom sidebar on changeforms (used for media item info)
.change-form .related-object-info {
    margin-bottom: 20px;
    box-sizing: border-box;

    img {
        width: 100%;
        height: auto;
    }

    .icon {
        font-size: 48px;
        color: var(--color-gray-500);

        &:hover {
            color: var(--link-fg);
        }
    }

    .media-related-item-list {
        padding-left: 20px;
    }

    @media (min-width: $tablet-width) {
        float: right;
        background: var(--color-white);
        padding: 10px 0 60px 60px;
        max-width: 260px;
    }
}

// Form "aligned" fieldset
form .aligned {
    margin-bottom: 10px;

    .help,
    div.help {
        font-size: 12px;
    }

    div.help,
    input + div.help,
    textarea + div.help,
    select + div.help {
        padding-top: 10px;
        padding-left: 4px;

        &:last-child {
            margin-left: 0;
        }
    }

    label + p,
    label + div.readonly,
    p.file-upload {
        margin-left: 0;
    }

    .clearable-file-input {
        display: inline-block;
        margin-left: 10px;

        label {
            display: inline !important;
            color: var(--error-fg);
        }
    }

    .form-row {
        @include clearfix;
        padding: 10px 0 15px 0;

        &:last-child {
            border-bottom: 0;
        }

        > div {
            margin-top: -4px;
        }

        // Input & Label styling
        .flex-container:not(.checkbox-row, .form-multiline, .fk-raw-id-container) {
            flex-direction: column;

            label:not(.vCheckboxLabel) {
                width: auto;
                padding-top: 0;
            }

            > .vTextField,
            > .vUUIDField,
            > .vLargeTextField,
            > .vXMLLargeTextField,
            > .vIntegerField,
            > .vBigIntegerField,
            > .vURLField,
            > input[type='password'] {
                max-width: calc(100% - 15px);
            }

            > .vTextField,
            > .vUUIDField,
            > .vLargeTextField,
            > .vXMLLargeTextField {
                width: calc(100% - 15px);
                max-width: 800px;
            }

            > input[type='password'] {
                max-width: 300px;
            }

            > .vForeignKeyRawIdAdminField {
                max-width: calc(100% - 36px);
            }

            select {
                align-self: start;
            }

            // datetime widget
            .datetime {
                padding-left: 5px;

                input.vDateField,
                input.vTimeField {
                    width: 78px;
                    min-width: 78px;
                    margin-left: 20px;
                }

                input.vTimeField {
                    position: relative;
                    left: -3px;
                }
            }

            // date fields
            .date {
                padding-top: 0;
            }
        }

        // Checkbox
        .flex-container.checkbox-row {
            padding-top: 8px;

            .vCheckboxLabel {
                padding-bottom: 0;
                cursor: pointer;
            }

            input {
                margin: 0;
            }

            & + .help {
                margin-top: 4px;
            }
        }

        // Single row with multiple fields (grouped form fields)
        .flex-container.form-multiline {
            gap: 15px;

            .checkbox-row {
                padding-top: 6px;
            }

            @media (min-width: $desktop-width) {
                gap: 15px 60px;
            }
        }

        .flex-container.fk-raw-id-container {
            flex-wrap: wrap;
            > label {
                flex-basis: 100%;
            }
        }

        // Used for grouped (side by side) fields
        .fieldBox {
            @media (max-width: ($tablet-width - 1px)) {
                clear: both;
            }
        }

        // Related object selector
        .related-widget-wrapper {
            overflow: visible;
        }

        // Lookup button for raw_id_fields
        .related-lookup {
            display: inline-block;
            width: auto;
            height: 26px;
            background: transparent;
            text-decoration: none;
            vertical-align: middle;
            margin: 0;
            padding: 0 5px;
            color: var(--color-gray-900);

            &::before {
                @include material-icons;
                display: inline-block;
                vertical-align: middle;
                content: 'search';
                font-size: 26px;
                width: 26px;
                height: 26px;
                margin-right: 5px;
            }

            &:hover {
                color: var(--link-fg);
            }
        }

        // mobile
        @media (max-width: ($tablet-width - 1px)) {
            padding-left: 0;
            padding-right: 0;
        }
    }
}

.form-row {
    overflow: visible;
}

.form-row.errors,
.fieldBox.errors {
    background: var(--message-error-bg);
    margin-bottom: -1px;

    .errorlist {
        background: var(--message-error-bg);
        margin-left: 0;
        padding-left: 0;
    }
}

// Remove botom border for last form fieldset
.change-form fieldset.module:last-of-type {
    .form-row:last-of-type {
        border-bottom: 0;
    }
}

.errornote {
    background: var(--error-fg);
    color: var(--color-white);
}

fieldset.module {
    h2 {
        margin-bottom: 15px;
        background: transparent;
        border: 0;
        border-bottom: solid 1px var(--color-gray-400);
    }
}

// Form submit row
.change-form .submit-row {
    box-sizing: border-box;
    position: fixed;
    z-index: 1000;
    bottom: 0;
    left: 0;
    width: 100%;
    margin: 0;
    padding: 10px 20px;
    background: var(--color-gray-100);
    border: 0;
    border-top: solid 1px var(--color-gray-300);
    border-radius: 0;

    display: grid;
    grid-auto-flow: column;
    grid-template-columns: 1fr repeat(3, auto);
    justify-items: left;
    gap: 8px;

    .deletelink {
        grid-column: 1;
        margin-left: 0;
    }
    input[name='_save'] {
        grid-column: 2;
    }
    input[name='_addanother'] {
        grid-column: 3;
    }
    input.default,
    input[name='default'] {
        grid-column: 4;
    }

    @media (min-width: $desktop-width) {
        input,
        a.deletelink {
            transform: scale(0.9);
        }
    }

    // mobile
    @media (max-width: ($desktop-width - 1px)) {
        // only show deault & delete buttons in mobile
        input:not(.default):not(.deletelink) {
            display: none;
        }
    }
}

// inlines
.inline-group {
    fieldset.module {
        h3 {
            padding: 10px;
            background: transparent;
            color: var(--color-gray-900);
            border-top: 0;
            font-weight: normal;

            span.delete {
                label {
                    cursor: pointer;
                    color: var(--color-gray-800);
                }

                input:checked + label {
                    color: var(--error-fg);
                }
            }
        }
    }

    .inline-related {
        background: var(--color-gray-50);
        border: solid 1px var(--color-gray-300);

        &:not(:last-child) {
            margin-bottom: 20px;
        }

        h3 {
            margin-bottom: 0 !important;
            border-bottom: solid 1px var(--color-gray-300) !important;
        }

        .form-row {
            padding: 10px;
        }

        &.will-delete {
            > *:not(h3):not(.delete),
            h3 > *:not(.delete) {
                opacity: 0.4;
                filter: saturate(0);
            }
        }
    }

    b,
    .inline_label {
        font-size: 12px;
    }

    .tabular {
        border: 0;
    }

    div.add-row {
        padding: 10px;
        border: solid 1px var(--color-gray-300);
        background: var(--color-gray-100);

        a:not(:last-of-type) {
            margin-right: 15px;
        }
    }
}

// calendar widget
.calendar caption,
.calendarbox h2 {
    background: var(--link-fg) !important;
    color: var(--color-white) !important;
}

.calendarbox .calendarnav-previous,
.calendarbox .calendarnav-next {
    filter: invert(100%) contrast(200%);
}

// selector (filter)
.selector {
    .selector-available,
    .selector-chosen {
        h2,
        h3 {
            background: transparent;
            color: var(--color-gray-900);
            margin-bottom: 0;
            border-bottom: solid 1px var(--color-gray-400);
        }

        .selector-filter {
            > label {
                float: left !important;
            }
        }
    }

    select {
        background: var(--color-white);
    }

    .selector-chosen {
        select {
            height: 20.8em;
        }
    }
}

// change-history
#change-history {
    td:nth-child(2) {
        white-space: nowrap;
    }
}

// TODO: not currently using this, either remove or fix Popup component
.modal-popup {
    position: fixed;
    top: 0;
    left: 0;
    z-index: 3000;
    width: 100%;
    height: 100%;

    &,
    * {
        box-sizing: border-box;
    }

    .modal-popup-content {
        position: absolute;
        z-index: 10;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 80%;
        height: 80%;
        background: var(--color-white);
    }

    .popup-iframe {
        width: 100%;
        height: 100%;
        border: 0;
    }

    .modal-close-button {
        position: absolute;
        top: -20px;
        right: -20px;
        width: 28px;
        height: 28px;
        font-size: 28px;
        line-height: 1;
        color: var(--color-gray-900);
        background: var(--color-white);
        border-radius: 50%;
    }

    .modal-overlay {
        position: fixed;
        top: 0;
        left: 0;
        width: 100vw;
        height: 100vh;
        background: rgba(0, 0, 0, 0.8);
    }
}
